var db;
var shortName = 'DJTDB';
var version = '1.0';
var displayName = 'DJTDB';
var maxSize = 1000000;

function onDeviceReady() {
//	db = window.openDatabase(shortName, version, displayName, maxSize);
//	db.transaction(crearBaseDades, errorHandler, successCB);
}

function crearBaseDades(tx) {

	var taules = [
			'CREATE TABLE IF NOT EXISTS JOC (id INTEGER PRIMARY KEY, nom TEXT, instruccions TEXT, thumbnail BLOB, taulell BLOB)',
			'CREATE TABLE IF NOT EXISTS FITXA (id INTEGER PRIMARY KEY, idjoc INTEGER REFERENCES JOC(id), tipus INTEGER, color TEXT, tamany INTEGER, posx INTEGER, posy INTEGER)',
			'CREATE TABLE IF NOT EXISTS DAU (id INTEGER PRIMARY KEY, idjoc INTEGER REFERENCES JOC(id), tipus INTEGER, min INTEGER, max INTEGER)' ];

	// tx.executeSql('UPDATE joc set taulell = null');
//	 tx.executeSql('DROP TABLE IF EXISTS JOC');
//	 tx.executeSql('DROP TABLE IF EXISTS FITXA');
//	 tx.executeSql('DROP TABLE IF EXISTS DAU');

	for ( var i = 0; i < taules.length; i++) {
		tx.executeSql(taules[i]);
	}

}

// this is called when an error happens in a transaction
function errorHandler(transaction, error) {
//	alert('Error: ' + error);
	alert('Error: ' + error.message + ' code: ' + error.code);
}
function successCB() {
	// alert('success');
}

function getJocById(pid, callback) {

	db = window.openDatabase(shortName, version, displayName, maxSize);
	db.transaction(function(tx) {
		tx.executeSql('SELECT * FROM JOC WHERE id = ?', [ pid ], function(tx, results) {
			var joc;
			var len = results.rows.length;
			if (len == 1) {
				var item = results.rows.item(0);
				joc = new Joc(item.id, item.nom, item.instruccions, item.thumbnail, item.taulell);

				tx.executeSql('SELECT * FROM FITXA WHERE idjoc = ?', [ joc.getId() ], function(tx, results) {
					var len = results.rows.length;
					for ( var i = 0; i < len; i++) {
						var item = results.rows.item(i);
						var fitxa = new Fitxa(item.id, item.idjoc, item.tipus, item.color, item.tamany, item.posx, item.posy);
						joc.addFitxa(fitxa);
					}
					
					tx.executeSql('SELECT * FROM DAU WHERE idjoc = ?', [ joc.getId() ], function(tx, results) {
						var len = results.rows.length;
						for ( var i = 0; i < len; i++) {
							var item = results.rows.item(i);							
							var dau = new Dau(item.id, item.idjoc, item.tipus, item.min, item.max);
							joc.addDau(dau);													
						}

						callback(joc);

					}, errorHandler);

				}, errorHandler);
			}

		}, errorHandler);

	}, errorHandler, null);

}

function setJoc(joc, callback) {
	db = window.openDatabase(shortName, version, displayName, maxSize);
	db.transaction(function(tx) {
		if (joc.getId() != null) {
			// si ja esta en la bbdd
			tx.executeSql('UPDATE JOC SET nom=?, instruccions=?, thumbnail = ?, taulell=? WHERE id = ?', [ joc.getNom(), joc.getInstruccions(),
					joc.getThumbnail(), joc.getTaulell(), joc.getId() ], function(tx, results) {

				insertaFitxesIDaus(tx, joc);
				callback(joc.getId());

			}, function(err) {
				alert("Error processing SQL: " + err.code);
			});
		} else {
			// si es nou
			tx.executeSql('INSERT INTO JOC (id, nom, instruccions,thumbnail, taulell) VALUES (?,?,?,?,?)', [ null, joc.getNom(), joc.getInstruccions(),
					joc.getThumbnail(), joc.getTaulell() ], function(tx, results) {
				joc.setId(results.insertId);
				insertaFitxesIDaus(tx, joc);
				callback(joc.getId());
			}, function(err) {
				alert("Error processing SQL: " + err.code);
			});
		}

	}, errorHandler, successCB);
}

function insertaFitxesIDaus(tx, joc) {
	
	tx.executeSql("DELETE FROM FITXA WHERE idjoc = ?", [ joc.getId() ], function(tx, results) {

		for ( var i = 0; i < joc.getFitxes().length; i++) {
			var f = joc.getFitxes()[i];

			tx.executeSql("INSERT INTO FITXA (idjoc, tipus, color, tamany, posx, posy) VALUES (?,?,?,?,?,?)", [ joc.getId(), f.getTipus(), f.getColor(),
					f.getTamany(), f.getPosx(), f.getPosy() ], function(tx, results2) {
				f.setId(results2.insertId);
				
			}, function(err) {
				alert("Error processing SQL: " + err.code);
			});

		}

	});

	tx.executeSql("DELETE FROM DAU  WHERE idjoc = ?", [ joc.getId() ], function(tx, results) {

		for ( var i = 0; i < joc.getDaus().length; i++) {
			var d = joc.getDaus()[i];
			tx.executeSql("INSERT INTO DAU (idjoc, tipus, min, max) VALUES (?,?,?,?)", [ joc.getId(), d.getTipus(), d.getMin(), d.getMax() ], function(tx,
					results2) {
				d.setId(results2.insertId);
				
			}, function(err) {
				alert("Error processing SQL: " + err.code);
			});

		}

	});

}

/**
 * Fa una query de tots els jocs. Executa un metode callback amb l'array de jocs
 * que ha trobat com a parametre p.ex:<br>
 * getAllJocs(function(jocs){<br>
 * for (var i=0; i < jocs.length;i++){<br>
 * //aqui treballem amb els jocs<br> }<br>
 * });<br>
 * 
 * @param callback
 * @returns {Array}
 */
function getAllJocs(callback) {

	db = window.openDatabase(shortName, version, displayName, maxSize);
	db.transaction(function(tx) {
		crearBaseDades(tx);
		tx.executeSql('SELECT id,nom,instruccions,thumbnail FROM JOC', null, function(tx, results) {
			var jocs = [];
			for ( var i = 0; i < results.rows.length; i++) {
				var item = results.rows.item(i);
				joc = new Joc(item.id, item.nom, item.instruccions, item.thumbnail);
				jocs[i] = joc;
			}

			callback(jocs);
		}, errorHandler);
	}, errorHandler, null);
}

function deleteJoc(idJoc) {
	db = window.openDatabase(shortName, version, displayName, maxSize);
	db.transaction(function(tx) {
		tx.executeSql('DELETE FROM dau WHERE idjoc = ?', [ idJoc ]);
		tx.executeSql('DELETE FROM fitxa WHERE idjoc = ?', [ idJoc ]);
		tx.executeSql('DELETE FROM joc WHERE id = ?', [ idJoc ]);
	}, errorHandler, null);
}

function Joc(pid, pnom, pinstruccions, pthumbnail, ptaulell) {

	this.id = pid;
	this.nom = pnom;
	this.instruccions = pinstruccions;
	this.thumbnail = pthumbnail;
	this.taulell = ptaulell;
	this.fitxes = [];
	this.daus = [];

	this.getFitxes = function() {
		return this.fitxes;
	};

	this.addFitxa = function(fitxa) {
		this.fitxes[this.fitxes.length] = fitxa;
	};

	this.getDaus = function() {
		return this.daus;
	};

	this.addDau = function(dau) {		
		this.daus[this.daus.length] = dau;
	};

	this.getId = function() {
		return this.id;
	};

	this.setId = function(idin) {
		this.id = idin;
	};

	this.getNom = function() {
		return this.nom;
	};

	this.setNom = function(inom) {
		this.nom = inom;
	};

	this.getInstruccions = function() {
		return this.instruccions;
	};

	this.setInstruccions = function(iinstruccions) {
		this.instruccions = iinstruccions;
	};

	this.getThumbnail = function() {
		return this.thumbnail;
	};

	this.setThumbnail = function(ithumbnail) {
		this.thumbnail = ithumbnail;
	};

	this.getTaulell = function() {
		return this.taulell;
	};

	this.setTaulell = function(itaulell) {
		this.taulell = itaulell;
	};

}

function Fitxa(pid, pidJoc, ptipus, pcolor, ptamany, pposx, pposy) {
	this.id = pid;
	this.idJoc = pidJoc;
	this.tipus = ptipus;
	this.color = pcolor;
	this.tamany = ptamany;
	this.posx = pposx;
	this.posy = pposy;

	this.getId = function() {
		return this.id;
	};

	this.setId = function(idin) {
		this.id = idin;
	};

	this.getIdJoc = function() {
		return this.idJoc;
	};

	this.setIdJoc = function(idJocIn) {
		this.idJoc = idJocIn;
	};

	this.getTipus = function() {
		return this.tipus;
	};

	this.setTipus = function(tipusIn) {
		this.tipus = tipusIn;
	};

	this.getColor = function() {
		return this.color;
	};

	this.setColor = function(colorIn) {
		this.color = colorIn;
	};

	this.getTamany = function() {
		return this.tamany;
	};

	this.setTamany = function(tamanyIn) {
		this.tamany = tamanyIn;
	};

	this.getPosx = function() {
		return this.posx;
	};

	this.setPosx = function(posxIn) {
		this.posx = posxIn;
	};

	this.getPosy = function() {
		return this.posy;
	};

	this.setPosy = function(posyIn) {
		this.posy = posyIn;
	};

}

function Dau(pid, pidJoc, ptipus, pmin, pmax) {

	this.id = pid;
	this.idJoc = pidJoc;
	this.tipus = ptipus;
	this.min = pmin;
	this.max = pmax;

	this.getId = function() {
		return this.id;
	};

	this.setId = function(idin) {
		this.id = idin;
	};

	this.getIdJoc = function() {
		return this.idJoc;
	};

	this.setIdJoc = function(idJocIn) {
		this.idJoc = idJocIn;
	};

	this.getTipus = function() {
		return this.tipus;
	};

	this.setTipus = function(tipusIn) {
		this.tipus = tipusIn;
	};

	this.getMin = function() {
		return this.min;
	};

	this.setMin = function(minIn) {
		this.min = minIn;
	};

	this.getMax = function() {
		return this.max;
	};

	this.setMax = function(maxIn) {
		this.max = maxIn;
	};

}
